
package sliderdemo005;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import javax.swing.JComponent;

/**
 *
 * @author Projekte
 */
public class DrawingPanel extends JComponent {
int strokeWidth = 1;
boolean kantenglaettung = false;
boolean mittellinie = false;

/**
 * Strichweite neu festlegen und Inhalt des Anzeigelements neu zeichnen.
 * @param sw ganzzahliger Wert: die neue Strichweite
 */
public void setStrokeWidth(int sw) {
    strokeWidth = sw;
    this.repaint();
}

/**
 * Kantenglättung ein- oder ausschalten und Inhalt des
 * Anzeigeelements neu zeichnen.
 * @param b
 */
public void setKantenglaettung(boolean b) {
    kantenglaettung = b;
    this.repaint();
}

/**
 * Anzeige der Mittellinie ein- oder ausschalten und Inhalt des
 * Anzeigeelements neu zeichnen.
 * @param b
 */
public void setMittellinie(boolean b) {
    mittellinie = b;
    this.repaint();
}

@Override
public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Dimension groesse = this.getSize();
        Rectangle bereich = new Rectangle(groesse);
        this.InhaltZeichnen((Graphics2D)g, bereich);
    }

private void InhaltZeichnen(Graphics2D g, Rectangle bereich){
        bereich.grow(-20, -20);
        g.setColor(new Color(255, 0, 0));
        RenderingHints einstellungen = new RenderingHints(
            RenderingHints.KEY_ANTIALIASING,
            kantenglaettung ? RenderingHints.VALUE_ANTIALIAS_ON
                : RenderingHints.VALUE_ANTIALIAS_OFF);
        g.addRenderingHints(einstellungen);
        g.setStroke(new BasicStroke(strokeWidth,
                    BasicStroke.CAP_ROUND,
                    BasicStroke.JOIN_ROUND));
        g.drawLine(bereich.x, bereich.y,
               bereich.x + bereich.width - 1,
               bereich.y + bereich.height - 1);
        if (mittellinie & strokeWidth > 2)
        {
            g.setColor(Color.white);
            g.setStroke(new BasicStroke(1));
            g.drawLine(bereich.x, bereich.y,
               bereich.x + bereich.width - 1,
               bereich.y + bereich.height - 1);
        }
    }
}
