
package sliderdemo005;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.FlowLayout;  /* new */
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;  /*  new  */
import javax.swing.JSlider;
/**
 *
 * @author Projekte
 */
public class Hauptprogramm implements Runnable {

    @Override
    public void run() {
        this.createAndShowGUI();
    }

    private void createAndShowGUI()
    {
        JFrame frame = new JFrame("Strichstärke");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        this.addComponentsToPane(frame.getContentPane());

        frame.pack();
        frame.setBounds(100, 100, 300, 300);
        frame.setVisible(true);
    }
    
    private void addComponentsToPane (Container container)
    {
        GridBagLayout layout = new GridBagLayout();
        container.setLayout(layout);

        JSlider slider = new JSlider(JSlider.VERTICAL, 1, 25, 1);
        JLabel wertanzeige = new JLabel("1", JLabel.CENTER);
        JCheckBox kantenglaettung = new JCheckBox("Kantenglättung");
        JCheckBox mittellinie = new JCheckBox("Mittellinie");
        DrawingPanel paintArea = new DrawingPanel();
        slider.addChangeListener(new SliderListener(paintArea, wertanzeige));
        kantenglaettung.setSelected(false);
        kantenglaettung.addItemListener (new CheckBoxItemListener(paintArea));
        mittellinie.setSelected(false);
        mittellinie.addItemListener (new CheckBoxItemListener2(paintArea));
        
        GridBagConstraints c = new GridBagConstraints();
        // wertanzeige platzieren
        c.fill = GridBagConstraints.VERTICAL;
        c.gridx = 0;
        c.gridy = 0;
        c.weightx = 0;
        c.weighty = 0;
        c.ipadx = 8;
        c.ipady = 8;
        c.insets = new Insets(2, 2, 2, 2);
        container.add(wertanzeige, c);
        
        // Schieberegler unter der Wertanzeige platzieren
        c = new GridBagConstraints();
        c.fill = GridBagConstraints.VERTICAL;
        c.gridx = 0;
        c.gridy = 1;
        c.weightx = 0;
        c.weighty = 1;
        c.ipadx = 8;
        c.ipady = 8;
        c.insets = new Insets(2, 2, 2, 2);
        container.add(slider, c);
        
        //  Zeichenfläche rechts neben allen anderen
        //  Darstellungselementen platzieren
        c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
        c.gridx = 1;
        c.gridy = 0;
        c.gridwidth = 1;
        c.gridheight = 2;
        c.weightx = 1;
        c.weighty = 1;
        container.add(paintArea, c);
        
        JPanel subpanel = new JPanel();
        c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
        c.gridx = 0;
        c.gridy = 2;
        c.gridwidth = 2;
        c.gridheight = 1;
        c.weightx = 1;
        c.weighty = 0;
        container.add(subpanel, c);
        
        subpanel.setLayout(new FlowLayout());
        subpanel.add(kantenglaettung);
        subpanel.add(mittellinie);
    }
}
